MaxCardinalitySearchDefaultTraits< GR, CAP > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Types | Static Public Member Functions
MaxCardinalitySearchDefaultTraits< GR, CAP > Struct Template Reference

## Detailed Description

### template<typename GR, typename CAP>
struct lemon::MaxCardinalitySearchDefaultTraits< GR, CAP >

Default traits class of MaxCardinalitySearch class.

Parameters

  Digraph | Digraph type.
  CapacityMap | Type of capacity map.

`#include <lemon/max_cardinality_search.h>`

## Public Types
typedef GR | Digraph
| The digraph type the algorithm runs on.
typedef CapMapSelector< CAP > ::CapacityMap | CapacityMap
| The type of the map that stores the arc capacities. More...
typedef CapacityMap::Value | Value
| The type of the capacity of the arcs.
typedef Digraph::template NodeMap< int > | HeapCrossRef
| The cross reference type used by heap. More...
typedef HeapSelector < CapacityMap >::template Selector< Value, HeapCrossRef > ::Heap | Heap
| The heap type used by MaxCardinalitySearch algorithm. More...
typedef NullMap< typename Digraph::Node, bool > | ProcessedMap
| The type of the map that stores whether a node is processed. More...
typedef Digraph::template NodeMap< Value > | CardinalityMap
| The type of the map that stores the cardinalities of the nodes. More...

## Static Public Member Functions
static CapacityMap * | createCapacityMap (const Digraph &digraph)
| Instantiates a CapacityMap. More...
static HeapCrossRef * | createHeapCrossRef (const Digraph &digraph)
| Instantiates a HeapCrossRef. More...
static Heap * | createHeap (HeapCrossRef &crossref)
| Instantiates a Heap. More...
static ProcessedMap * | createProcessedMap (const Digraph &digraph)
| Instantiates a ProcessedMap. More...
static CardinalityMap * | createCardinalityMap (const Digraph &digraph)
| Instantiates a CardinalityMap. More...

## Member Typedef Documentation

typedef CapMapSelector<CAP>::CapacityMap CapacityMap

The type of the map that stores the arc capacities. It must meet the ReadMap concept.

typedef Digraph::template NodeMap<int> HeapCrossRef

The cross reference type used by heap. Usually it is `Digraph::NodeMap<int>`.

typedef HeapSelector<CapacityMap>::template Selector<Value, HeapCrossRef>::Heap Heap

The heap type used by MaxCardinalitySearch algorithm. It should maximalize the priorities. The default heap type is the BinHeap, but it is specialized when the CapacityMap is ConstMap<Digraph::Node, Const<int, 1> > to BucketHeap.

See Also
  MaxCardinalitySearch

typedef NullMap<typename Digraph::Node, bool> ProcessedMap

The type of the map that stores whether a node is processed. It must meet the WriteMap concept. By default it is a NullMap.

typedef Digraph::template NodeMap<Value> CardinalityMap

The type of the map that stores the cardinalities of the nodes. It must meet the WriteMap concept.

## Member Function Documentation

static CapacityMap* createCapacityMap | ( | const Digraph & | digraph | ) |
| inlinestatic

This function instantiates a CapacityMap.

Parameters

  digraph | is the digraph, to which we would like to define the CapacityMap.

static HeapCrossRef* createHeapCrossRef | ( | const Digraph & | digraph | ) |
| inlinestatic

This function instantiates a HeapCrossRef.

Parameters

  digraph | is the digraph, to which we would like to define the HeapCrossRef.

static Heap* createHeap | ( | HeapCrossRef & | crossref | ) |
| inlinestatic

This function instantiates a Heap.

Parameters

  crossref | The cross reference of the heap.

static ProcessedMap* createProcessedMap | ( | const Digraph & | digraph | ) |
| inlinestatic

This function instantiates a ProcessedMap.

Parameters

  digraph | is the digraph, to which we would like to define the ProcessedMap

static CardinalityMap* createCardinalityMap | ( | const Digraph & | digraph | ) |
| inlinestatic

This function instantiates a CardinalityMap.

Parameters

  digraph | is the digraph, to which we would like to define the CardinalityMap